Draft WorkingPlaneProxy

From FreeCAD Documentation
This documentation is a work in progress. Please don't mark it as translatable since it will change in the next hours and days.

Draft WorkingPlaneProxy

Menu location
Utilities → Create working plane proxy
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
-
See also
Draft SelectPlane

Description

This command will place a Plane Proxy object aligned to the current Working Plane.

This proxy object can be used like a face to quickly change the working plane using the Draft SelectPlane tool. The camera position and visibility of the objects in the 3D view can be saved in the proxy object, and restored at anytime when the Draft SelectPlane tool is used.

Three working plane proxies showing different orientations and offsets

Usage

  1. Make sure the Working Plane is set as you want.
  2. Then go to the menu Utilities → Create Working Plane Proxy.

Tree view context menu

For Draft WorkingPlaneProxy objects the following additional options are available in the Tree view context menu:

  • Write camera position: updates the ViewView Data property of the WP proxy with the current 3D view camera settings.
  • Write objects state: updates the ViewVisibility Map property of the WP proxy with the current visibility state of all objects in the document.

Notes

  • The working plane stored in the Proxy object can be restored by double-clicking the object in the tree view, or by selecting the Proxy object and using the Draft SelectPlane button.
  • Plane proxies can be moved and rotated like any other object so that they define the desired working plane. Their visual appearance can also be changed in the Property editor.

Properties

See also: Property editor.

A Draft WorkingPlaneProxy object is derived from an App FeaturePython object and inherits all its properties. It also has the following additional properties:

Data

Base

  • DataPlacement (Placement): specifies the position of the WP proxy in the 3D view. See Placement.
  • Data (Hidden)Shape (Shape): specifies the shape of the WP proxy.

View

Arch

  • ViewArrow Size (Length): specifies the size of the arrow symbols displayed at the tip of the three axes.
  • ViewDisplay Size (Length): specifies the length and width of the WP proxy.

Base

  • ViewLine Color (Color): specifies the color of all elements of the WP proxy.
  • ViewLine Width (Float): specifies the line width of the axes and arrow symbols.
  • ViewRestore State (Bool): specifies if the ViewVisibility Map is restored when the WP proxy is double-clicked in the Tree view or used with the Draft SelectPlane command.
  • ViewRestore View (Bool): specifies if the ViewView Data is restored when the WP proxy is double-clicked in the Tree view or used with the Draft SelectPlane command.
  • ViewTransparency (Percent): specifies the transparency of the face of the WP proxy.
  • ViewView Data (FloatList): specifies the camera position and settings.
  • View (Hidden)Visibility Map (Map): specifies the visibility state of objects.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To create a Draft WorkingPlaneProxy use the make_workingplaneproxy method of the Draft module.

If the Draft Workbench is active the FreeCAD application object has a DraftWorkingPlane property which stores the current Draft working plane. The Placement from the getPlacement method of the DraftWorkingPlane object can be used to create an aligned WP proxy. The Placement of a WP proxy in turn can be used to realign the Draft working plane.

# This code only works if the Draft Workbench is active!

import FreeCAD as App
import FreeCADGui as Gui
import Draft

doc = App.newDocument()

workplane = App.DraftWorkingPlane
place = workplane.getPlacement()

proxy = Draft.make_workingplaneproxy(place)
proxy.ViewObject.DisplaySize = 3000
proxy.ViewObject.ArrowSize = 200

axis2 = App.Vector(1, 1, 1)
point2 = App.Vector(3000, 0, 0)
place2 = App.Placement(point2, App.Rotation(axis2, 90))

proxy2 = Draft.make_workingplaneproxy(place2)
proxy2.ViewObject.DisplaySize = 3000
proxy2.ViewObject.ArrowSize = 200

workplane.setFromPlacement(proxy2.Placement, rebase=True)
Gui.Snapper.setGrid()

doc.recompute()